// modified for HOLY WARS

#include "g_local.h"

// HOLY WARS
#include "cnf_maps.h"
// HWv2.1
#include "stdlog.h"	//	StdLog - Mark Davies
#include "gslog.h"	//	StdLog - Mark Davies
// end HOLY WARS

game_locals_t   game;
level_locals_t  level;
game_import_t   gi;
game_export_t   globals;
spawn_temp_t    st;

int     sm_meat_index;
int     snd_fry;
int meansOfDeath;

edict_t         *g_edicts;

cvar_t  *deathmatch;
cvar_t  *coop;
cvar_t  *dmflags;
cvar_t  *skill;
cvar_t  *fraglimit;
cvar_t  *timelimit;
cvar_t  *password;
cvar_t  *maxclients;
cvar_t  *maxentities;
cvar_t  *g_select_empty;
cvar_t  *dedicated;

cvar_t  *sv_maxvelocity;
cvar_t  *sv_gravity;

cvar_t  *sv_rollspeed;
cvar_t  *sv_rollangle;
cvar_t  *gun_x;
cvar_t  *gun_y;
cvar_t  *gun_z;

cvar_t  *run_pitch;
cvar_t  *run_roll;
cvar_t  *bob_up;
cvar_t  *bob_pitch;
cvar_t  *bob_roll;

cvar_t  *sv_cheats;

//HK:Begin - Added Keys2 stuff.
//K2:Begin - Server cvars
cvar_t	*giveshotgun;			//0 off 1 on
cvar_t	*givesupershotgun;		//0 off 1 on
cvar_t	*givemachinegun;		//0 off 1 on
cvar_t	*givechaingun;			//0 off 1 on
cvar_t	*givegrenadelauncher;	//0 off 1 on
cvar_t	*giverocketlauncher;	//0 off 1 on
cvar_t	*giverailgun;			//0 off 1 on
cvar_t	*givehyperblaster;		//0 off 1 on
cvar_t	*givebfg;				//0 off 1 on

cvar_t	*nobfg;					//0 off 1 on
cvar_t	*noshotgun;				//0 off 1 on
cvar_t	*nosupershotgun;		//0 off 1 on
cvar_t	*nomachinegun;			//0 off 1 on
cvar_t	*nochaingun;			//0 off 1 on
cvar_t	*nogrenadelauncher;		//0 off 1 on
cvar_t	*norocketlauncher;		//0 off 1 on
cvar_t	*nohyperblaster;		//0 off 1 on
cvar_t	*norailgun;				//0 off 1 on
cvar_t	*nomegahealth;			//0 off 1 on
cvar_t	*noquad;				//0 off 1 on
cvar_t	*noinvulnerability;		//0 off 1 on
cvar_t	*swaat;					//0 off 1 on

cvar_t	*startinghealth;		//100 - 1000
cvar_t	*startingshells;		//100 - 1000
cvar_t	*startingbullets;		//100 - 1000
cvar_t	*startinggrenades;		//100 - 1000
cvar_t	*startingrockets;		//100 - 1000
cvar_t	*startingslugs;			//100 - 1000
cvar_t	*startingcells;			//100 - 1000
cvar_t	*maxhealth;				//100 - 1000
cvar_t	*maxshells;				//100 - 1000
cvar_t	*maxbullets;			//100 - 1000
cvar_t	*maxgrenades;			//100 - 1000
cvar_t	*maxrockets;			//100 - 1000
cvar_t	*maxslugs;				//100 - 1000
cvar_t	*maxcells;				//100 - 1000
cvar_t	*startingweapon;		//100 - 1000
cvar_t	*startingarmorcount;	//100 - 1000
cvar_t	*startingarmortype;		//100 - 1000

cvar_t	*hook_time;				//0 = infinite 999 max
cvar_t	*hook_speed;			//100 - 1400 Hook velocity
cvar_t	*hook_damage;			//2 - 50 Damage done by hook
cvar_t	*pull_speed;			//100 - 1400 How fast the player is pulled;
cvar_t	*skyhook;

cvar_t	*protecttime;			//5 - 30
cvar_t	*gibtime;				//10 - 60
cvar_t	*burntime;				//10 - 60
cvar_t	*blindtime;				//???
cvar_t	*flash_radius;			//???
cvar_t	*pickuptime;			//???
cvar_t	*gibdamage;				//2 - 10
cvar_t	*burndamage;			//2 - 10

cvar_t	*regentime;				//30 - 300
cvar_t	*hastetime;				//30 - 300
cvar_t	*futilitytime;			//30 - 300
cvar_t	*inflictiontime;		//30 - 300
cvar_t	*bfktime;				//30 - 300
cvar_t	*stealthtime;			//30 - 300
cvar_t	*homingtime;			//30 - 300
cvar_t	*antitime;				//30 - 300

cvar_t	*regeneration;	//0 - 4 for number of keys
cvar_t	*haste	;		//0 - 4 for number of keys
cvar_t	*futility;		//0 - 4 for number of keys
cvar_t	*infliction;	//0 - 4 for number of keys
cvar_t	*bfk;			//0 - 4 for number of keys
cvar_t	*stealth;		//0 - 4 for number of keys
cvar_t	*antikey;		//0 - 4 for number of keys
cvar_t	*homing;			//0 - 4 for number of keys

//k2flags->value flags
cvar_t	*droppable	;		//0 off 1 on
cvar_t	*playershells;		//0 off 1 on
cvar_t	*keyshells	;		//0 off 1 on
cvar_t	*respawntime;		//1 or 2 minutes
cvar_t	*pickupannounce;	//0 off 1 on

//k2weapons->value flags
cvar_t	*gibgun	;			//0 off 1 on
cvar_t	*flashgrenades;		//0 off 1 on
cvar_t	*firegrenades;		//0 off 1 on
cvar_t	*firerockets;		//0 off 1 on
cvar_t	*drunkrockets;		//0 off 1 on
cvar_t	*hominghyper;		//0 off 1 on

cvar_t	*motd1;
cvar_t	*motd2;
cvar_t	*motd3;

//k2gameplay->value flags
cvar_t	*usevwep;			//0 off 1 on
cvar_t	*damagemultiply;	//0 off 1 on

//weapon damage
cvar_t	*bfgdamage;
cvar_t	*raildamage;
cvar_t	*supershotgundamage;
cvar_t	*shotgundamage;
cvar_t	*chaingundamage;
cvar_t	*machinegundamage;
cvar_t	*hyperdamage;
cvar_t	*blasterdamage;
cvar_t	*rocketdamage;
cvar_t	*rocketradiusdamage;
cvar_t	*rocketdamageradius;
cvar_t	*grenadelauncherdamage;
cvar_t	*handgrenadedamage;


//Global Vars
float	k2_keyframes;
float	qversion;
//K2:End
//HK:End

void SpawnEntities (char *mapname, char *entities, char *spawnpoint);
void ClientThink (edict_t *ent, usercmd_t *cmd);
qboolean ClientConnect (edict_t *ent, char *userinfo);
void ClientUserinfoChanged (edict_t *ent, char *userinfo);
void ClientDisconnect (edict_t *ent);
void ClientBegin (edict_t *ent);
void ClientCommand (edict_t *ent);
void RunEntity (edict_t *ent);
void WriteGame (char *filename, qboolean autosave);
void ReadGame (char *filename);
void WriteLevel (char *filename);
void ReadLevel (char *filename);
void InitGame (void);
void G_RunFrame (void);


//===================================================================


void ShutdownGame (void)
{
        gi.dprintf ("==== ShutdownGame ====\n");

// HOLY WARS
// HWv2.1
		sl_GameEnd( &gi, level );	// StdLog - Mark Davies
// end HOLY WARS

        gi.FreeTags (TAG_LEVEL);
        gi.FreeTags (TAG_GAME);
}


/*
=================
GetGameAPI

Returns a pointer to the structure with all entry points
and global variables
=================
*/
game_export_t *GetGameAPI (game_import_t *import)
{
        gi = *import;

        globals.apiversion = GAME_API_VERSION;
        globals.Init = InitGame;
        globals.Shutdown = ShutdownGame;
        globals.SpawnEntities = SpawnEntities;

        globals.WriteGame = WriteGame;
        globals.ReadGame = ReadGame;
        globals.WriteLevel = WriteLevel;
        globals.ReadLevel = ReadLevel;

        globals.ClientThink = ClientThink;
        globals.ClientConnect = ClientConnect;
        globals.ClientUserinfoChanged = ClientUserinfoChanged;
        globals.ClientDisconnect = ClientDisconnect;
        globals.ClientBegin = ClientBegin;
        globals.ClientCommand = ClientCommand;

        globals.RunFrame = G_RunFrame;

        globals.ServerCommand = ServerCommand;

        globals.edict_size = sizeof(edict_t);

        return &globals;
}

#ifndef GAME_HARD_LINKED
// this is only here so the functions in q_shared.c and q_shwin.c can link
void Sys_Error (char *error, ...)
{
        va_list         argptr;
        char            text[1024];

        va_start (argptr, error);
        vsprintf (text, error, argptr);
        va_end (argptr);

        gi.error (ERR_FATAL, "%s", text);
}

void Com_Printf (char *msg, ...)
{
        va_list         argptr;
        char            text[1024];

        va_start (argptr, msg);
        vsprintf (text, msg, argptr);
        va_end (argptr);

        gi.dprintf ("%s", text);
}

#endif

//======================================================================


/*
=================
ClientEndServerFrames
=================
*/
void ClientEndServerFrames (void)
{
        int             i;
        edict_t *ent;

        // calc the player views now that all pushing
        // and damage has been added
        for (i=0 ; i<maxclients->value ; i++)
        {
                ent = g_edicts + 1 + i;
                if (!ent->inuse || !ent->client)
                        continue;
                ClientEndServerFrame (ent);
        }

}

/*
=================
EndDMLevel

The timelimit or fraglimit has been exceeded
=================
*/
void EndDMLevel (void)
{
        edict_t         *ent;

// HOLY WARS
        HW_EndOfLevel();
// end HOLY WARS

        // stay on same level flag
  if ((int)dmflags->value & DF_SAME_LEVEL)
        {
                ent = G_Spawn ();
                ent->classname = "target_changelevel";
                ent->map = level.mapname;
        }

// HOLY WARS
  // This rotates Holy Wars maps.
  else
        {
        int num_of_players;      // total number of player
        int mean_ping;          // mean value of players' ping
        char *next_map;         // next map assigned by HW rotation file
                        // the following declaration has paranoid purposes:
                        // IF someone calls the loader func. while the map is loaded
                        // THEN this maybe changes the string pointed by ent->map
                        // I don't know how ID software works (I think very well ... but...)
                        // so I spend 64 bytes and a copy to sing "Don't worry, be happy"
        static char HW_next_map_string [MAX_QPATH];

                // load the number of "connected" player and their mean ping
        num_of_players = HW_GetPlayerAndMediumPing(&mean_ping);
                // read from configuration file the next map name according with the parameters
        next_map = CNF_MAP_LoadMap(level.mapname, num_of_players, mean_ping);
        if(next_map != NULL)
                {       // found the next map
                strcpy(HW_next_map_string, next_map);   // copy the string found
                ent = G_Spawn ();
                ent->classname = "target_changelevel";
                ent->map = HW_next_map_string;
                }
        else
                if (level.nextmap[0])
                        {       // go to a specific map
                        ent = G_Spawn ();
                        ent->classname = "target_changelevel";
                        ent->map = level.nextmap;
                        }
                else
                        {       // search for a changelevel
                        ent = G_Find (NULL, FOFS(classname), "target_changelevel");
                        if (!ent)
                                {       // the map designer didn't include a changelevel,
                                        // so create a fake ent that goes back to the same level
                                ent = G_Spawn ();
                                ent->classname = "target_changelevel";
                                ent->map = level.mapname;
                                }
                        }
        }
// end HOLY WARS
        BeginIntermission (ent);
}

/*
=================
CheckDMRules
=================
*/
void CheckDMRules (void)
{
        int                     i;
        gclient_t       *cl;

        if (level.intermissiontime)
                return;

        if (!deathmatch->value)
                return;

        if (timelimit->value)
        {
                if (level.time >= timelimit->value*60)
                {
                        gi.bprintf (PRINT_HIGH, "Timelimit hit.\n");
                        EndDMLevel ();
                        return;
                }
        }

        if (fraglimit->value)
        {
                for (i=0 ; i<maxclients->value ; i++)
                {
                        cl = game.clients + i;
                        if (!g_edicts[i+1].inuse)
                                continue;

                        if (cl->resp.score >= fraglimit->value)
                        {
                                gi.bprintf (PRINT_HIGH, "Fraglimit hit.\n");
                                EndDMLevel ();
                                return;
                        }
                }
        }
}


/*
=============
ExitLevel
=============
*/
void ExitLevel (void)
{
        int             i;
        edict_t *ent;
        char    command [256];

        Com_sprintf (command, sizeof(command), "gamemap \"%s\"\n", level.changemap);
        gi.AddCommandString (command);
        level.changemap = NULL;
        level.exitintermission = 0;
        level.intermissiontime = 0;
        ClientEndServerFrames ();

        // clear some things before going to next level
        for (i=0 ; i<maxclients->value ; i++)
        {
                ent = g_edicts + 1 + i;
                if (!ent->inuse)
                        continue;
                if (ent->health > ent->client->pers.max_health)
                        ent->health = ent->client->pers.max_health;
        }

}

/*
================
G_RunFrame

Advances the world by 0.1 seconds
================
*/
void G_RunFrame (void)
{
        int             i;
        edict_t *ent;

        level.framenum++;
        level.time = level.framenum*FRAMETIME;

        // choose a client for monsters to target this frame
        AI_SetSightClient ();

        // exit intermissions

        if (level.exitintermission)
        {
                ExitLevel ();
                return;
        }

        //
        // treat each object in turn
        // even the world gets a chance to think
        //
        ent = &g_edicts[0];
        for (i=0 ; i<globals.num_edicts ; i++, ent++)
        {
                if (!ent->inuse)
                        continue;

                level.current_entity = ent;

                VectorCopy (ent->s.origin, ent->s.old_origin);

                // if the ground entity moved, make sure we are still on it
                if ((ent->groundentity) && (ent->groundentity->linkcount != ent->groundentity_linkcount))
                {
                        ent->groundentity = NULL;
                        if ( !(ent->flags & (FL_SWIM|FL_FLY)) && (ent->svflags & SVF_MONSTER) )
                        {
                                M_CheckGround (ent);
                        }
                }

                if (i > 0 && i <= maxclients->value)
                {
                        ClientBeginServerFrame (ent);
                        continue;
                }

                G_RunEntity (ent);
        }

        // see if it is time to end a deathmatch
        CheckDMRules ();

        // build the playerstate_t structures for all players
        ClientEndServerFrames ();
}

